// set the dimensions and margins of the graph
const width = 1000;
const height = 400;

// append the svg object to the body of the page
const svg = d3
  .select('#my_dataviz')
  .append('svg')
  .attr('width', width * 0.8)
  .attr('height', height);

const svg2 = d3
  .select('#my_dataviz')
  .append('svg')
  .attr('width', width * 0.2)
  .attr('height', height);

function render(mapData) {
  var projection = d3
    .geoAlbersUsa()
    .fitSize([width * 0.8, height], mapData);
  var path = d3.geoPath(projection);

  svg
    .append('g')
    .selectAll('path')
    .data(mapData.features)
    .join('path')
    // draw each country
    .attr('fill', 'blue')
    .on('mouseover', function (event, data) {
      console.log(d3.select(this));
      d3.select(this).attr('fill', 'red');
      console.log(data.properties);
      //console.log(d3.pointer(event)[0]);
      d3.select('#my_text')
        .style('position', 'absolute')
        .style('left', d3.pointer(event)[0] - 50 + 'px')
        .style('top', d3.pointer(event)[1] - 50 + 'px')
        .style('visibility', 'visible')
        .html(
          '' +
            this.id +
            ', pop: ' +
            data.properties.population +
            '',
        );
      d3.selectAll('circle').attr(
        'r',
        data.properties.population / 1000000,
      );
    })
    .on('mouseleave', function (event, data) {
      d3.select(this).attr('fill', 'blue');
      d3.select('#my_text').style('visibility', 'hidden');
    })
    .attr('id', (d) => d.properties.state)
    .attr('d', path);

  svg2
    .append('circle')
    .attr('fill', 'red')
    .attr('cx', '50')
    .attr('cy', '200')
    .attr('r', '10');
}

//Read the data
const mapUrl =
  'https://raw.githubusercontent.com/holtzy/D3-graph-gallery/master/DATA/world.geojson';
const usMapUrl =
  'https://raw.githubusercontent.com/ResidentMario/geoplot-data/master/contiguous-usa.geojson';

function normalizeCountryName(s) {
  return s.replaceAll(' ', '_').toLowerCase();
}

Promise.all([d3.json(usMapUrl)]).then(([mapData]) => {
  console.log(mapData);
  render(mapData);
});
